diff --git a/src/packages/fff/fff-boardname/Makefile b/src/packages/fff/fff-boardname/Makefile
index 31e6731..499ae91 100644
--- a/src/packages/fff/fff-boardname/Makefile
+++ b/src/packages/fff/fff-boardname/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=fff-boardname
-PKG_VERSION:=0.0.2
+PKG_VERSION:=3
 PKG_RELEASE:=1
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)
diff --git a/src/packages/fff/fff-boardname/files/etc/uci-defaults/50-fff-boardname b/src/packages/fff/fff-boardname/files/etc/uci-defaults/50-fff-boardname
old mode 100755
new mode 100644
index 94b9884..5470405
--- a/src/packages/fff/fff-boardname/files/etc/uci-defaults/50-fff-boardname
+++ b/src/packages/fff/fff-boardname/files/etc/uci-defaults/50-fff-boardname
@@ -16,11 +16,18 @@ case "$BOARD" in
         grep 740 /var/sysinfo/model && BOARD=tl-wr740n-v4
         ;;
     tl-wr841n-v7)
-        BOARD=tl-wr841nd-v7
+        BOARD=tl-wr841-v7
+        ;;
+    tl-wr841n-v8)
+        BOARD=tl-wr841-v8
         ;;
     tl-wr841n-v9)
-        grep "v10" /var/sysinfo/model && BOARD=tl-wr841n-v10
-        grep "v11" /var/sysinfo/model && BOARD=tl-wr841n-v11
+        BOARD=tl-wr841-v9
+        grep "v10" /var/sysinfo/model && BOARD=tl-wr841-v10
+        ;;
+    tl-wr841n-v11)
+        BOARD=tl-wr841-v11
+        grep "v12" /var/sysinfo/model && BOARD=tl-wr841-v12
         ;;
     nanostation-m)
         BOARD=ubnt-nano-m
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v10 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v10
new file mode 100644
index 0000000..4d22fde
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v10
@@ -0,0 +1,10 @@
+PORTORDER="4 3 2 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=eth1
+ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v11 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v11
new file mode 100644
index 0000000..4d22fde
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v11
@@ -0,0 +1,10 @@
+PORTORDER="4 3 2 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=eth1
+ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v12 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v12
new file mode 100644
index 0000000..4d22fde
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v12
@@ -0,0 +1,10 @@
+PORTORDER="4 3 2 1"
+
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=eth1
+ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v7 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v7
new file mode 100644
index 0000000..7a56a98
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v7
@@ -0,0 +1,8 @@
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=eth1
+ROUTERMAC=wlan0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8
new file mode 100644
index 0000000..af79caf
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v8
@@ -0,0 +1,10 @@
+PORTORDER="2 3 4 1"
+
+WANDEV=eth0
+SWITCHDEV=eth1
+CLIENT_PORTS="1 4 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 2 0t"
+
+ETHMESHMAC=eth0
+ROUTERMAC=eth1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v9 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v9
new file mode 100644
index 0000000..1d3f146
--- /dev/null
+++ b/src/packages/fff/fff-network/ar71xx/network.tl-wr841-v9
@@ -0,0 +1,8 @@
+WANDEV=eth1
+SWITCHDEV=eth0
+CLIENT_PORTS="1 2 0t"
+WAN_PORTS=
+BATMAN_PORTS="3 4 0t"
+
+ETHMESHMAC=eth1
+ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v10 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v10
deleted file mode 100644
index 4d22fde..0000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v10
+++ /dev/null
@@ -1,10 +0,0 @@
-PORTORDER="4 3 2 1"
-
-WANDEV=eth1
-SWITCHDEV=eth0
-CLIENT_PORTS="1 2 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=eth1
-ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v11 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v11
deleted file mode 100644
index 4d22fde..0000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v11
+++ /dev/null
@@ -1,10 +0,0 @@
-PORTORDER="4 3 2 1"
-
-WANDEV=eth1
-SWITCHDEV=eth0
-CLIENT_PORTS="1 2 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=eth1
-ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v8 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v8
deleted file mode 100644
index af79caf..0000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v8
+++ /dev/null
@@ -1,10 +0,0 @@
-PORTORDER="2 3 4 1"
-
-WANDEV=eth0
-SWITCHDEV=eth1
-CLIENT_PORTS="1 4 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 2 0t"
-
-ETHMESHMAC=eth0
-ROUTERMAC=eth1
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v9 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v9
deleted file mode 100644
index 1d3f146..0000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841n-v9
+++ /dev/null
@@ -1,8 +0,0 @@
-WANDEV=eth1
-SWITCHDEV=eth0
-CLIENT_PORTS="1 2 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=eth1
-ROUTERMAC=eth0
diff --git a/src/packages/fff/fff-network/ar71xx/network.tl-wr841nd-v7 b/src/packages/fff/fff-network/ar71xx/network.tl-wr841nd-v7
deleted file mode 100644
index 7a56a98..0000000
--- a/src/packages/fff/fff-network/ar71xx/network.tl-wr841nd-v7
+++ /dev/null
@@ -1,8 +0,0 @@
-WANDEV=eth1
-SWITCHDEV=eth0
-CLIENT_PORTS="1 2 0t"
-WAN_PORTS=
-BATMAN_PORTS="3 4 0t"
-
-ETHMESHMAC=eth1
-ROUTERMAC=wlan0
diff --git a/src/packages/fff/fff-sysupgrade/Makefile b/src/packages/fff/fff-sysupgrade/Makefile
index b2e1ffa..4a03652 100644
--- a/src/packages/fff/fff-sysupgrade/Makefile
+++ b/src/packages/fff/fff-sysupgrade/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=fff-sysupgrade
-PKG_VERSION:=5
+PKG_VERSION:=6
 PKG_RELEASE:=4
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)
diff --git a/src/packages/fff/fff-sysupgrade/files/etc/sysupgrade.sh b/src/packages/fff/fff-sysupgrade/files/etc/sysupgrade.sh
index 8aaa924..8ef4949 100755
--- a/src/packages/fff/fff-sysupgrade/files/etc/sysupgrade.sh
+++ b/src/packages/fff/fff-sysupgrade/files/etc/sysupgrade.sh
@@ -30,16 +30,6 @@ case $BOARD in
         BOARD="cpe210-220" ;;
     cpe510 )
         BOARD="cpe510-520" ;;
-    wr841nd-v7 )
-        BOARD="wr841-v7" ;;
-    wr841n-v8 )
-        BOARD="wr841-v8" ;;
-    wr841n-v9 )
-        BOARD="wr841-v9" ;;
-    wr841n-v10 )
-        BOARD="wr841-v10" ;;
-    wr841n-v11 )
-        BOARD="wr841-v11" ;;
 esac
 
 wget "${UPGRADE_PATH}/release.nfo"
